﻿//     ___                        _                    _     
//    / _ \_   _ _ __  _ __   ___| |_  /\/\   __ _ ___| |_ ___ _ __ 
//   / /_)/ | | | '_ \| '_ \ / _ \ __|/    \ / _` / __| __/ _ \ '__|
//  / ___/| |_| | |_) | |_) |  __/ |_/ /\/\ \ (_| \__ \ ||  __/ |  
//  \/     \__,_| .__/| .__/ \___|\__\/    \/\__,_|___/\__\___|_|  
//              |_|   |_|                   
//
//  Inspired from great mods & modders
//  
//  "AutoAim" by Puppyguard & ofc the Legendary "Active Humans!" by quaq
//
//  Nothing here can be considered original or mine. It has already been
//  thought of and done better by someone much more creative than meself.
//  Any credit goes to all of those who paved the way providing sample code.
//
//  For these coders below I've learned from the mods they have contributed
//  and am very grateful and lucky to be able to do that.
//
// -= Aspa102 Azule Blocksify jimmyl morzz1c Pump3d Pumpkin weirdo Woowz11 =-
//
//  (+ many more) and ofc the one & only...         -= zooi =- 
//
//  Thanks
//
//  If for any reason anybody wants to use any of this code, please do.
//
//  If you have any tips on how to do things more efficiently,
//  I would appreciate any tips I can get.
//
using System;
using UnityEngine;
namespace PuppetMaster
{
    public class JTMain
    {
        public static int MaxThingsOnGround        = 20;

        [SkipSerialisation] public static Sprite SpeedometerSprite;
        [SkipSerialisation] public static AudioClip DoorClose;
        [SkipSerialisation] public static AudioClip CarIdle;
        [SkipSerialisation] public static AudioClip CarEngine;
        [SkipSerialisation] public static AudioClip CarUnlock1;
        [SkipSerialisation] public static AudioClip CarUnlock2;
        [SkipSerialisation] public static AudioClip CarStart;
        [SkipSerialisation] public static AudioClip InvGun;
        [SkipSerialisation] public static AudioClip InvRifle;
        [SkipSerialisation] public static AudioClip InvShotgun;
        [SkipSerialisation] public static AudioClip InvKnife;
        [SkipSerialisation] public static AudioClip InvSword;
        [SkipSerialisation] public static SpriteRenderer SpeedometerSR;

        public static VerboseLevels Verbose   = VerboseLevels.Minimal;

        public static void OnLoad()
        {
            int savedVerbose = PlayerPrefs.GetInt("PB_Verbose", (int)VerboseLevels.Minimal);
            
            if (Enum.IsDefined(typeof(VerboseLevels),savedVerbose))
                Verbose = (VerboseLevels)savedVerbose;


            
            KB.InitControls();
        }

        public static void Main()
        {
            SpeedometerSprite      = ModAPI.LoadSprite("shtuff/speedometer.png", 1f, false);
            DoorClose              = ModAPI.LoadSound("shtuff/close-door.mp3");
            CarIdle                = ModAPI.LoadSound("shtuff/car-idle.mp3");
            CarEngine              = ModAPI.LoadSound("shtuff/car-engine.mp3");
            CarUnlock1             = ModAPI.LoadSound("shtuff/car-unlock1.mp3");
            CarUnlock2             = ModAPI.LoadSound("shtuff/car-unlock2.mp3");
            CarStart               = ModAPI.LoadSound("shtuff/car-start.mp3");
            InvGun                 = ModAPI.LoadSound("shtuff/gun-out.mp3");
            InvShotgun             = ModAPI.LoadSound("shtuff/shotgun-out.mp3");
            InvRifle               = ModAPI.LoadSound("shtuff/rifle-out.mp3");
            InvKnife               = ModAPI.LoadSound("shtuff/knife-out.mp3");
            InvSword               = ModAPI.LoadSound("shtuff/sword-out.mp3");

            ModAPI.Register<PuppetSwitch>();
        }
    }


    public class PuppetSwitch : MonoBehaviour
    {
        private static bool _announcements = false;

        void Update()
        {
            if (InputSystem.Down("PM-TogglePM")) TogglePuppetMode();
        }

        private void TogglePuppetMode()
        {
            if (KB.Alt)
            {
                // Set verbose mode
                int verbose = ((int)JTMain.Verbose + 1) % 3;

                JTMain.Verbose = (VerboseLevels)verbose;

                Util.Notify("<color=yellow>VERBOSE LEVEL:</color> " + Enum.GetName(typeof(VerboseLevels), verbose), VerboseLevels.Off);

                PlayerPrefs.SetInt("PB_Verbose", verbose);

                return;

            }

            PuppetMaster pm = Global.main.gameObject.GetOrAddComponent<PuppetMaster>();

            if (pm.Activated)
            {
                KB.SwapBindings(false);
                pm.Activated = false;
                pm.ShutDown();

                Util.Notify("Puppet Master: <color=red>Off</color>", VerboseLevels.Minimal);
            }
            else
            {
                KB.SwapBindings(true);
                pm.Activated = true;

                if (JTMain.Verbose == VerboseLevels.Full && !_announcements) {
                    Util.Notify("<color=red>PM Notifications are set to <color=yellow>FULL<color=red> Press ALT-F7 for less notifications</color>");
                    _announcements = true;
                }

                Util.Notify("Puppet Master: <color=green>On</color>", VerboseLevels.Minimal);
            }
        }
    }
}